

import java.util.Random;

/**
 * A simple counter
 */
public class Counter
{

    private int value;
    private Random randomGenerator;

    /**
     * Constructor
     */
    public Counter()
    {
        value = 0;
        randomGenerator = new Random();
    }

    /**
     * Count up by 10, taking a break now and then.
     */
    public void count()
    {
        int count = 0;
        
        try
        {
            while( count < 10 )
            {
                // silly way to increment the value but we're trying
                // to make a point here!
                value = increment( value );

                // generate a random number between 0 and 5 to
                // sleep for up to .5 seconds
                Thread.sleep( randomGenerator.nextInt( 6 ) * 100 );
                
                count++;
            }
        }
        catch( InterruptedException e )
        {
            // allow method to terminate if thread is interrupted
        }
    }

    /**
     * Counter's value
     * 
     * @return The counter's current value
     */
    public int get()
    {
        return value;
    }

    /**
     * @return n+1
     * @throws InterruptedException 
     */
    private int increment( int n ) throws InterruptedException
    {
        // generate a random number between 0 and 5 to
        // sleep for up to .5 seconds
        Thread.sleep( randomGenerator.nextInt( 6 ) * 100 );
        return n + 1;
    }

}
